<?php
/* vim: set expandtab tabstop=2 shiftwidth=2: */

//------------------------------------------------------------------------------

define('HOME_DIR', '/var/www/html/pm9fw_user');
define('HOME_URL', 'http://210.143.195.221/pm9fw_user');

define('DB_HOST_GLOBAL', 'localhost');
define('DB_NAME_GLOBAL', 'pm9fw_user');
define('DB_HOST', 'localhost');
define('DB_NAME', 'pm9fw_user');
define('DB_USER', 'root');
define('DB_PASS', '');

function db_check_global($sql) {
    return 0;
}

define('MAIL_RETURN_PATH', 'none@dummy.co.jp');

//------------------------------------------------------------------------------

$HOME_DIR = HOME_DIR;
define('CONFIG_DIR', "$HOME_DIR/config/");
define('TEMPLATE_DIR', "$HOME_DIR/design/html/");
define('TEMPLATE_MAIL_DIR', "$HOME_DIR/template_mail/");
define('APP_DIR', '_app/');

define('LOG_DIR', "$HOME_DIR/log/");
$LOG_DIR = LOG_DIR;
define('TRACE_FILE', "$LOG_DIR/trace.{$_SERVER['REMOTE_ADDR']}");



function odd_even(&$win, $label, &$odd_even) {
  switch ($odd_even) {
  case 'odd': $odd_even = 'even'; break;
  case 'even': $odd_even = 'odd'; break;
  default: $odd_even = 'odd'; break;
  }
  $win->assign($label, $odd_even);
}


function _number($num) {
  return (int)trim(preg_replace('/[^0-9.-]/', '', $num));
}


function _date_to_ymd($date) {
  $date = trim($date);
  if (preg_match("/^(\d{4})[-\/](\d{1,2})[-\/](\d{1,2})/", $date, $match)) {
    if ($match[2]>0) {
      return array($match[1], $match[2], $match[3]);
    } else {
      return array('', '', '');
    }
  } else {
    return array('', '', '');
  }
}


function _ymd_to_date($yy, $mm, $dd) {
  if ($mm) {
    return sprintf("%04d/%02d/%02d", $yy, $mm, $dd);
  } else {
    return '';
  }
}


function _date_format_ymd($date) {
  $date = trim($date);
  if (preg_match("/^(\d{4})[-\/](\d{1,2})[-\/](\d{1,2})/", $date, $match)) {
    return sprintf("%04d/%02d/%02d", $match[1], $match[2], $match[3]);
  } else {
    return '';
  }
}


function _date_format_ymd_kanji($date) {
  $date = trim($date);
  if (preg_match("/^(\d{4})[-\/](\d{1,2})[-\/](\d{1,2})/", $date, $match)) {
    return sprintf("%04dǯ%02d%02d", $match[1], $match[2], $match[3]);
  } else {
    return '';
  }
}


function _date_format($date) {
  $date = trim($date);
  if (preg_match("/^(\d{4})[-\/](\d{1,2})[-\/](\d{1,2})\s(\d{2}):(\d{1,2}):(\d{1,2})/", $date, $match)) {
    return sprintf("%04d/%02d/%02d %02d:%02d:%02d", $match[1], $match[2], $match[3], $match[4], $match[5], $match[6]);
  } else if (preg_match("/^(\d{4})[-\/](\d{1,2})[-\/](\d{1,2})/", $date, $match)) {
    return sprintf("%04d/%02d/%02d", $match[1], $match[2], $match[3]);
  } else {
    return '';
  }
}


function calc_taxprice($data) {
  return floor($data * 1.05);
}


function calc_tax($data) {
  return floor($data * 0.05);
}


function session_copy() {
  $new_session_id = md5(session_id());
  $spath = session_save_path();
  $ssym = 'sess_';
  $sid = session_id();
  copy("$spath/$ssym$sid", "$spath/$ssym$new_session_id");
  return $new_session_id;
}

function output_filter($resp) {
  if (strstr($resp, '_NEWSESSIONID_')) {
    $sn = session_name();
    $new_session_id = session_copy();
    $new_session_id_url = "$sn=$new_session_id";
    $new_session_id_form = "<input type='hidden' name='$sn' value='$new_session_id'>";
  }

  $tmp = array(

  '_SESSIONID_' => session_name().'='.session_id(),
  '_NEWSESSIONIDURL_' => $new_session_id_url,
  '_NEWSESSIONID_' => $new_session_id_form,
  '_HOMEURL_' => HOME_URL,
  ''
  );
	
  foreach($tmp as $org => $new) {
    if (!$org) continue;
    $resp = str_replace($org, $new, $resp);
  }
	
  return $resp;
}


define (FATAL,E_USER_ERROR);
define (ERROR,E_USER_WARNING);
define (WARNING,E_USER_NOTICE);

error_reporting (E_ALL ^ E_NOTICE);

set_error_handler("my_error_handler");

function my_error_handler($errno, $errstr, $errfile, $errline) {
  if(error_reporting() == 0) return;
  global $__sess;
  global $__portletvars;
  global $__cache;
  global $__cache_time;
  global $__validate_form_list;
  global $_POST;
  switch ($errno) {
  case FATAL:
  case WARNING:
  case E_WARNING:
  case E_ERROR:
  case E_USER:
    if ($errno == FATAL) {
      $win_err = new pm9mvc();
      $win_err->init(TEMPLATE_DIR . 'error.html');
      $win_err->assign('MESSAGE', $errstr);
      $win_err->finish();
      $resp = $win_err->get_contents();
      $resp = output_filter($resp);
      echo $resp;
    } else {
      echo "<b>WARNING</b> [$errno] $errstr<br>\n";
    }

    list($usec, $sec) = explode(" ",microtime());
    $tmpdate = strftime("%Y%m%d-%H%M%S.").sprintf('%03d', $usec*1000);
    $__log_fp=fopen(LOG_DIR.$tmpdate, "a");

    ob_start();

    echo "###### " . strftime('%Y/%m/%d %H:%M:%S') . "\n";
    echo "$errstr\n";
    $tmp = pm9mvc::debug_print_backtrace();
    $tmp = preg_replace('/<.*?>/', '', $tmp);
    $tmp = str_replace('&nbsp;', ' ', $tmp);
    echo $tmp;
    echo "\n";
    echo "__sess               ===================================\n";
    var_dump($__sess);
    echo "__portletvars        ===================================\n";
    var_dump($__portletvars);
    echo "__cache              ===================================\n";
    var_dump($__cache);
    echo "__cache_time         ===================================\n";
    var_dump($__cache_time);
    echo "__validate_form_list ===================================\n";
    var_dump($__validate_form_list);
    echo "_POST                ===================================\n";
    var_dump($_POST);

    fwrite($__log_fp, ob_get_contents());
    fclose($__log_fp);
    ob_end_clean();

    if ($errno == FATAL) {
      exit -1;
    }
    break;
  }
}

function topic_path($list, $current) {
  $co = 0;
  $stat = 0;
  $topic = "";
  foreach($list as $name => $action_list) {
    $nosel = 0;

    if (strstr($action_list, '=>')) {
      list($tmp, $target) = split('=>', $action_list);
      $action_arr = split(',', $tmp);
      if (strstr($target, '#')) $nosel = 1;
      $target = str_replace('#', '', $target);
    } else {
      $target = $action_list;
      if (strstr($target, '#')) $nosel = 1;
      $target = str_replace('#', '', $target);
      $action_arr = array($target);
    }

    if ($co > 0) {
      $topic .= ' :: ';
    }
    if (in_array($current, $action_arr)) {
      $stat = 1;
    } else if ($stat == 1) {
      $stat = 2;
    }
    if ($stat == 0 && $nosel == 0) {
      $topic .= "<a href='i.php?_CONTROL_URL&_ACTION[$target]=1'>$name</a>";
    } else if ($stat == 1) {
      $topic .= "*$name";
    } else {
      $topic .= "$name";
    }
    $co++;
  }
  return $topic;
}

function trace_time_track($memo) {
  global $time_list;
  if (!$time_list) $time_list = array();

  global $pre_time;

  list($usec, $sec) = explode(" ", microtime());
  $now_time = ((float)$usec + (float)$sec);

  if ($pre_time) {
    $span_time = $now_time - $pre_time;
  } else {
    $span_time = 0;
  }
  $time_list[] = "$span_time :: $memo";
  $pre_time = $now_time;
}

?>
