<?php
/* vim: set expandtab tabstop=2 shiftwidth=2: */

class validate {

	function check_kana($rec, $field, &$err) {
		if (!trim($rec[$field])) return;
		if (!mbereg("^[-]*$", $rec[$field])) $err[$field] = 'kana';
	} 


	function check_kana9($rec, $field, &$err) {
		if (!trim($rec[$field])) return;
		if (!mbereg("^[--0-9]*$", $rec[$field])) $err[$field] = 'kana9';
	} 


	function check_kanji($rec, $field, &$err) {
		if (!trim($rec[$field])) return;
		if (!trim($rec[$field])) $err[$field] = 'kanji';
	} 
	

	function check_mail($rec, $field, &$err) {
		if (!trim($rec[$field])) return;
		if (!eregi("^[0-9,A-Z,a-z][0-9,a-z,A-Z,_,\.,-]+@[0-9,A-Z,a-z][0-9,a-z,A-Z,_,\.,-]+\.[0-9,A-Z,a-z]{2,3}$", $rec[$field])) $err[$field] = 'mail';
	} 
	

	function check_passwd($rec, $field, &$err) {
		if (!trim($rec[$field])) return; 
		if (!eregi("^[0-9a-z]{4,8}$", $rec[$field])) $err[$field] = 'passwd';
	} 
	

	function check_require($rec, $field, &$err) {
		if (!trim($rec[$field])) $err[$field] = 'req';
	} 
	

	function check_tel($rec, $field, &$err) {
		if (!trim($rec[$field])) return;
		if (!eregi('^[0-9]*$', $rec[$field])) $err[$field] = 'tel';
	} 


	function check_price($rec, $field, &$err) {
		if (!trim($rec[$field])) return;
		if (!eregi('^[0-9,]*$', $rec[$field])) $err[$field] = 'price';
	} 
	

	function check_zip($rec, $field, &$err) {
		if (!trim($rec["{$field}1"]) && !trim($rec["{$field}2"])) return;
		if (!eregi('^[0-9]{3}$', $rec["{$field}1"]) || !eregi('^[0-9]{4}$', $rec["{$field}2"])) {
			$err[$field] = 'zip';
			$err["{$field}1"] = 'zip';
			$err["{$field}2"] = 'zip';
		} 
	} 
	

	function check_gender($rec, $field, &$err) {
		if (!$rec[$field]) {
			$err[$field] = 'gender';
		} 
	} 


	function check_equal($rec, $field, &$err) {
    $tmp_field = str_replace('2', '', $field);
		if ($rec[$field] != $rec[$tmp_field]) {
			$err[$field] = 'equal';
		} 
	} 
	

	function check_date($rec, $field, &$err) {
		if (!trim($rec[$field])) return;
		if (preg_match("/^(\d{4})[-\/](\d{1,2})[-\/](\d{1,2})$/", trim($rec[$field]), $match)) {
			if (!checkdate($match[2], $match[3], $match[1])) {
				$err[$field] = 'date';
			} 
		} else {
			$err[$field] = 'date';
		} 
	} 
}
