<?
/* vim: set expandtab tabstop=2 shiftwidth=2: */

/*
 * PM9 Web Framework
 * (C) 2004, Kunimasa Noda/PM9.com, Inc. <http://www.pm9.com,  kuni@pm9.com>
 * see file LICENSE for license details
 */


function pm9mvc_get_param_name($list, $cur, $step, $sym) {
	$i = $cur;
	$i += $step;
	while (abs($i) <= count($list)) {
		if (!strstr($list[$i], '$')) {
			$name = str_replace(array('{', '#', '@'), array('', '', ''), $list[$i]);
			return str_replace($sym, $name, $list[$cur]);
		}
		$i += $step;
	}
	return '';
}

function pm9mvc_scan_param_name($list, $cur) {
	$i = $cur - 3;
	while ($i >= 0 || $i <= count($list)) {
		if (strstr($list[$i + 2], '<')) break;
		if (!strstr($list[$i], '$')) {
			$name = str_replace(array('{', '#', '@'), array('', '', ''), $list[$i]);
			return str_replace('$1', $name, $list[$cur]);
		}
		$i -= 3;
	}
	$i = $cur + 3;
	while ($i >= 0 || $i <= count($list)) {
		if (strstr($list[$i - 2], '>')) break;
		if (!strstr($list[$i], '$')) {
			$name = str_replace(array('{', '#', '@'), array('', '', ''), $list[$i]);
			return str_replace('$1', $name, $list[$cur]);
		}
		$i += 3;
	}
	return '';
}

function pm9mvc_radio_check_replace($match) {
	$name = str_replace(array('{', '#', '@', '}'), array('', '', '', ''), $match[4]);
	$value = $match[6];
	return $match[1] . '{' . $name . '/radio_checked::' . $value . '}';
}

function pm9mvc_checkbox_check_replace($match) {
	$name = str_replace(array('{', '#', '@', '}'), array('', '', '', ''), $match[4]);
	$value = $match[6];
	return $match[1] . '{' . $name . '/checkbox_checked::' . $value . '}';
}

function pm9mvc_opt_sel_replace($match) {
  if (strstr($match[4], '</select')) {
    return '_____<<PM9____'.substr($match[0], 1);
  }
	$name = str_replace(array('{', '#', '@', '}'), array('', '', '', ''), $match[3]);
	$value = $match[6];
	return $match[1] . '{' . $name . '/option_selected::' . $value . '}';
}

function pm9mvc_opt_sel_mark_replace($match) {
  if (strstr($match[4], '</select')) {
    return '_____<<PM9____'.substr($match[0], 1);
  }
	$name = str_replace(array('{', '#', '@', '}'), array('', '', '', ''), $match[3]);
	$value = $match[6];
	return $match[1] . '{' . $name . '/selected_mark::' . $value . '}';
}

function pm9mvc_extend_param_name($data) {
	$list = preg_split('/(\{#{0,1}@{0,1}\?{0,1}[_a-zA-Z0-9]*\${0,1}[_a-zA-Z0-9]*)([^\}\s]*\})/', $data, -1, PREG_SPLIT_DELIM_CAPTURE);
	$data = '';
	for($i = 0; $i < count($list); $i++) {
		$elem = $list[$i];
		if ($elem[0] == '{') {
			if (strstr($elem, '$0')) {
				$data .= pm9mvc_get_param_name($list, $i, -3, '$0');
			} else if (strstr($elem, '$2')) {
				$data .= pm9mvc_get_param_name($list, $i, 3, '$2');
			} else if (strstr($elem, '$1')) {
				$data .= pm9mvc_scan_param_name($list, $i);
			} else {
				$data .= $elem;
			}
			$i++;
			$data .= $list[$i];
		} else {
			$data .= $elem;
		}
	}
	$data = preg_replace('/{{.*?}}/', '', $data);

	$data = preg_replace_callback('/(?xmsi)(<input[^>]*type=([\'"]{0,1})radio\\2[^>]*name=([\'"]{0,1})([^>]*?)\\3[^>]*value=([\'"]{0,1})([^>]*?)\\5[^>]*){\$checked}/', 'pm9mvc_radio_check_replace', $data);

	$data = preg_replace_callback('/(?xmsi)(<input[^>]*type=([\'"]{0,1})checkbox\\2[^>]*name=([\'"]{0,1})([^>]*?)\\3[^>]*value=([\'"]{0,1})([^>]*?)\\5[^>]*){\$checked}/', 'pm9mvc_checkbox_check_replace', $data);


  while(preg_match('/(?xmsi)(<select[^>]*?name=([\'"]{0,1})([^>]*?)\\2.*?>.*?<option[^>]*value=([\'"]{0,1})([^>]*?)\\4[^>]*){\$selected}/', $data)) {
	  $data = preg_replace_callback('/(?xmsi)(<select[^>]*name=([\'"]{0,1})([^>]*?)\\2.*?>(.*?)<option[^>]*value=([\'"]{0,1})([^>]*?)\\5[^>]*){\$selected}/', 'pm9mvc_opt_sel_replace', $data);
  }
  $data = str_replace('_____<<PM9____select', '<select', $data);

	$data = preg_replace('/\{#([_a-zA-Z0-9]+)\}/', '$1', $data);

	return $data;
}

define("T_BYFILE", 0);
define("T_BYVAR", 1);

define("PM9MVC_TOP_BLOCK", 'TOP_BL');

class pm9mvc extends pm9frame {
	var $index = Array();
	var $content = Array();

	var $currentBlock;
	var $serialized;
	var $globalvars = Array();
	var $setupd;

	function is_exist_block($block) {
		return is_array($this->_bl[$block]);
  }

	function set_values($func_convert, &$rec, $block = PM9MVC_TOP_BLOCK, $field_name_extend = null) {
    pm9mvc::_check_args(func_get_args(), 'pm9mvc::set_values',
      array('func_convert' => 'str', 'rec' => 'array', 'block = PM9MVC_TOP_BLOCK' => 'str', 'field_name_extend = null' => 'str'));

    $this->goto_block($block);

		foreach($this->_bl[$block] as $tmp => $field_name) {
			if (substr($tmp, 0, 3) != '_t:') continue;
			if (strstr($field_name, '__')) continue;

      if (strstr($field_name, '@')) {
        $f_name = str_replace(array('#', '@'), array('', ''), $field_name);
        if ($field_name_extend) {
          $f_name = $field_name_extend.'['.$f_name.']';
        }
        $this->assign($field_name, $f_name);
        continue;
      }

      if (strstr($field_name, '#')) {
        $f_name = str_replace(array('#', '@'), array('', ''), $field_name);
        $this->assign($field_name, $f_name);
        continue;
      }

      if ($field_name[0] == '&') {
        continue;
      }
      if ($field_name[0] == '?') {
        continue;
      }
      list($f_name, $f_attr) = split('/', $field_name);
      list($f_attr1, $f_attr2) = split('::', $f_attr);
			$tmp = call_user_func($func_convert, $this, $rec, $f_name, $f_attr1, $f_attr2);
echo $field_name;
echo $tmp;
			$this->assign($field_name, $tmp);

      if ($__trace_mode_tpl_dump) {
        require('_include/trace_start.php');
        echo "@@@ ASSIGN: ";
        echo "$field_name => $tmp\n";
        require('_include/trace_end.php');
      }
		}
	}

	function validate($func_validator, &$rec, &$err_list, $block = PM9MVC_TOP_BLOCK, $exclude=array()) {
    pm9mvc::_check_args(func_get_args(), 'pm9mvc::validate',
      array('func_validator' => 'str', 'rec' => 'array', '__err_list' => 'ret', 'block = PM9MVC_TOP_BLOCK' => 'str', 'exclude = array()' => 'array'));

		foreach($this->_bl[$block] as $tmp => $field_name) {
			if (substr($tmp, 0, 3) != '_t:') continue;
			if (strstr($field_name, '__')) continue;
      if ($field_name[0] != '?') continue;

      $field_name = str_replace('?', '', $field_name);
      list($f_name, $f_attr) = split('/', $field_name);
      list($f_attr1, $f_attr2) = split('::', $f_attr);
      if (in_array($field_name, $exclude)) continue;
			call_user_func($func_validator, &$rec, $f_name, $f_attr1, $f_attr2, &$err_list);
		}
	}


  function validate_root($function, &$rec, &$__err_list, $exclude=array()) {
    pm9mvc::_check_args(func_get_args(), 'pm9mvc::validate_root',
      array('function' => 'str', 'rec' => 'array', '__err_list' => 'ret', 'exclude = array()' => 'array'));

    global $__validate_tpl;

    $__err_list = array();
    $tpl_check = new pm9mvc($__validate_tpl);
    $tpl_check->setup();
    $tpl_check->validate($function, &$rec, &$__err_list, PM9MVC_TOP_BLOCK, $exclude);
    return $tpl_check;
  }


  function validate_block($tpl_check, $block, $function, &$rec, &$__err_list, $exclude=array()) {
    pm9mvc::_check_args(func_get_args(), 'pm9mvc::validate_root',
      array('tpl_check' => 'object', 'block' => 'str', 'function' => 'str', 'rec' => 'array', '__err_list' => 'ret', 'exclude = array()' => 'array'));

    $tpl_check->validate($function, &$rec, &$__err_list, $block);
    return;
  }


  function check_reload() {
    global $__sess;
    global $__sess_seq;

    $ret = ($__sess_seq != ($__sess['__sess_seq']));
    return $ret;
  }


  function set_page_control(&$tpl, $block_list, &$_, $num_rows, &$rec_start) {
    pm9mvc::_check_args(func_get_args(), 'pm9mvc::set_page_control',
      array('tpl' => 'object', 'block_list' => 'array', '_' => 'array', 'num_rows' => 'int', 'rec_start' => 'any'));

    $block_first = null;
    foreach($block_list as $block) {

      if (!$block_first) $block_first = $block;
  	  $tpl->new_block($block);
  	  $tpl->goto_block($block);
  	  if (!$_["_PGCTL_PER_PAGE"]) $_["_PGCTL_PER_PAGE"] = 100;
  	  $per_page = $_["_PGCTL_PER_PAGE"];
  
  	  if (!$_["_P_PG"]) $_["_P_PG"] = 1;
  	  $page = $_["_P_PG"];
  
  	  $rec_start = ($page - 1) * $per_page;
      if ($rec_start > $num_rows) {
  	    $page = $_["_P_PG"] = 1;
  	    $rec_start = ($page - 1) * $per_page;
      }
  	
  	  $page_links = 6;
  	  $num_pages = ceil($num_rows / $per_page);
      $_['_NUM_PAGES'] = $num_pages;
      $_['_NUM_ROWS'] = $num_rows;
  	
  	  if ($page > 1) {
  	    $tpl->goto_block($block);
  	    $tpl->new_block('_PGCTL_NOT_FIRST_PAGE_'.$block.'_BL');
  	    $prev_page = $page - 1;
  	    $tpl->assign('_PGCTL_PREV_PAGE', $prev_page);
        $tpl->assign('_PGCTL_'.$block.'_BLOCK', $block);
  	  } else {
  	    $tpl->goto_block($block);
  	    $tpl->new_block('_PGCTL_FIRST_PAGE_'.$block.'_BL');
  	  }
  	
  	  $cur_window_num = intval($page / $page_links);
  	  if ($page % $page_links) $cur_window_num++;
  	  $max_window_num = intval($num_pages / $page_links);
  	  if ($num_pages % $page_links) $max_window_num++;
  	  if ($cur_window_num > 1) {
  	    $tpl->goto_block($block);
  	    $tpl->new_block('_PGCTL_CUR_WINDOW_ETCB_'.$block.'_BL');
  	    $num = ($cur_window_num - 1) * $page_links;
  	    $tpl->assign('_PGCTL_ETC_PAGE', $num);
        $tpl->assign('_PGCTL_'.$block.'_BLOCK', $block);
  	  }
  	  for ($jump_to_page = 1 + (($cur_window_num - 1) * $page_links); ($jump_to_page <= ($cur_window_num * $page_links)) && ($jump_to_page <= $num_pages); $jump_to_page++) {
  	    $tpl->new_block('_PGCTL_PAGE_LINK_'.$block.'_BL');
  	    if ($jump_to_page == $page) {
  	      $tpl->new_block('_PGCTL_CURRENT_PAGE_'.$block.'_BL');
  	      $tpl->assign('_PGCTL_JUMP_TO_PAGE', $jump_to_page);
          $tpl->assign('_PGCTL_'.$block.'_BLOCK', $block);
  	    } else {
  	      $tpl->new_block('_PGCTL_JUMP_PAGE_'.$block.'_BL');
  	      $tpl->assign('_PGCTL_JUMP_TO_PAGE', $jump_to_page);
          $tpl->assign('_PGCTL_'.$block.'_BLOCK', $block);
  	    }
  	  }
  	  if ($cur_window_num < $max_window_num) {
  	    $tpl->goto_block($block);
  	    $tpl->new_block('_PGCTL_CUR_WINDOW_ETCA_'.$block.'_BL');
  	    $num = $cur_window_num * $page_links + 1;
  	    $tpl->assign('_PGCTL_ETC_PAGE', $num);
        $tpl->assign('_PGCTL_'.$block.'_BLOCK', $block);
  	  }
  	  if (($page < $num_pages) && ($num_pages != 1)) {
  	    $tpl->goto_block($block);
  	    $tpl->new_block('_PGCTL_NOT_LAST_PAGE_'.$block.'_BL');
  	    $next_page = $page + 1;
  	    $tpl->assign('_PGCTL_NEXT_PAGE', $next_page);
        $tpl->assign('_PGCTL_'.$block.'_BLOCK', $block);
  	  } else {
  	    $tpl->goto_block($block);
  	    $tpl->new_block('_PGCTL_LAST_PAGE_'.$block.'_BL');
  	  }
  	  $tpl->goto_block($block);
  	  $tpl->assign('_PGCTL_PER_PAGE', $_["_PGCTL_PER_PAGE"]);
    }
  }


  function err_count2($tmp_err) {
    global  $__err_count;
    foreach($tmp_err as $tmp_key => $tmp_content) {
      if (is_array($tmp_content)) {
        pm9mvc::err_count2($tmp_content);
      } else if (trim($tmp_content)) {
        $__err_count++;
      }
    }
  }


  function err_count($tmp_err) {
    global  $__err_count;
    $__err_count = 0;
    if (is_array($tmp_err)) {
      foreach($tmp_err as $tmp_key => $tmp_content) {
        if (is_array($tmp_content)) {
          pm9mvc::err_count2($tmp_content);
        } else if (trim($tmp_content)) {
          $__err_count++;
        }
      }
    }
    return $__err_count;
  }


  function &get_pvars($pvar_id) {
    global $__portletvars;

    if (!is_array($__portletvars)) $__portletvars = array();
    if (!is_array($__portletvars[$pvar_id])) $__portletvars[$pvar_id] = array();
    return $__portletvars[$pvar_id];
  }


  function &current_pvars($pvar_id) {
    global $__PVAR_ID;

    $__PVAR_ID = $pvar_id;
    return pm9mvc::get_pvars($__PVAR_ID);
  }


  function copy_pvars($pvar_id, $varname_list = array()) {
    pm9mvc::_check_args(func_get_args(), 'pm9mvc::copy_pvars',
      array('pvar_id' => 'str', 'varname_list = array()' => 'array'));

    global $__portletvars;

    foreach($varname_list as $tmp => $val) {
      $__portletvars[$pvar_id][$tmp] = $val;
    }
  }


  function copy_current_pvars($varname_list = array()) {
    pm9mvc::_check_args(func_get_args(), 'pm9mvc::copy_current_pvars',
      array('varname_list = array()' => 'array'));

    global $__portletvars;
    global $__PVAR_ID;

    if ($varname_list) foreach($varname_list as $tmp => $val) {
      $__portletvars[$__PVAR_ID][$tmp] = $val;
    }
  }


  function clear_pvars($pvar_id) {
    pm9mvc::_check_args(func_get_args(), 'pm9mvc::clear_pvars',
      array('pvar_id' => 'str'));

    global $__portletvars;

    $__portletvars[$pvar_id] = array();
  }


  function clear_current_pvars() {
    pm9mvc::_check_args(func_get_args(), 'pm9mvc::clear_current_pvars',
      array());

    global $__portletvars;
    global $__PVAR_ID;

    $__portletvars[$__PVAR_ID] = array();
  }


  function _abort_func_illargs($err, $func, $rule, $args) {
    ob_start();
    echo "<b>Notice:</b> $err<br>\n";
    echo "usage: $func(";
    $comma = "";
    foreach($rule as $var_name => $var_type) {
      echo "$comma$var_type \$$var_name";
      $comma = ", ";
    }
    echo ");<br>\n";
    echo "argument: ";
    var_dump($args);
//    echo "<hr>backtrace:<br>";
//    pm9mvc::debug_print_backtrace();
    session_destroy();
    $message = ob_get_contents();
    ob_end_clean();
    trigger_error($message, E_USER_ERROR);
    exit;
  }

   function debug_print_backtrace() {
       $s = '';
       if (PHPVERSION() >= 4.3) {
       
           $MAXSTRLEN = 640;
       
           $s = '<pre align=left>';
           $traceArr = debug_backtrace();
           array_shift($traceArr);
           $tabs = sizeof($traceArr)-1;
           foreach ($traceArr as $arr) {
               for ($i=0; $i < $tabs; $i++) $s .= ' &nbsp; ';
               $tabs -= 1;
               $s .= '<font face="Courier New,Courier">';
               if (isset($arr['class'])) $s .= $arr['class'].'.';
               foreach($arr['args'] as $v) {
                   if (is_null($v)) $args[] = 'null';
                   else if (is_array($v)) $args[] = 'Array['.sizeof($v).']';
                   else if (is_object($v)) $args[] = 'Object:'.get_class($v);
                   else if (is_bool($v)) $args[] = $v ? 'true' : 'false';
                   else { 
                       $v = (string) @$v;
                       $str = htmlspecialchars(substr($v,0,$MAXSTRLEN));
                       if (strlen($v) > $MAXSTRLEN) $str .= '...';
                       $args[] = $str;
                   }
               }
               
               $s .= $arr['function'].'('.implode(', ',$args).')';
               $s .= sprintf("</font><font color=#808080 size=-1> # line %4d,".
  " file: <a href=\"file:/%s\">%s</a></font>",
  $arr['line'],$arr['file'],$arr['file']);
               $s .= "\n";
           }    
           $s .= '</pre>';
//           print $s;
       }
       return $s;
   } 

  function _check_args($args, $func, $rule) {
    $count_args = count($args);
    $count_rule = count($rule);
    if ($count_args > $count_rule) {
      pm9mvc::_abort_func_illargs('Illegal argument num', $func, $rule, $args);
    }
    if ($count_args < $count_rule) {
      $count = 0;
      foreach($rule as $var_name => $var_type) {
        if ($count >= $count_args) break;
        $count++;
      }
      if (!strstr($var_name, '=')) {
        pm9mvc::_abort_func_illargs('Illegal argument num', $func, $rule, $args);
      }
    }
    $count = 0;
    foreach($rule as $var_name => $var_type) {
      if ($count >= $count_args) break;
      switch($var_type) {
      case 'bool': if (!is_bool($args[$count])) $error_arg_type = true; break;
      case 'int': if (!is_integer($args[$count])) $error_arg_type = true; break;
      case 'float': if (!is_float($args[$count])) $error_arg_type = true; break;
      case 'num': if (!is_numeric($args[$count])) $error_arg_type = true; break;
      case 'str': if (!is_string($args[$count])) $error_arg_type = true; break;
      case 'array': if (!(is_array($args[$count]) || $args[$count] == null)) $error_arg_type = true; break;
      case 'object': if (!is_object($args[$count])) $error_arg_type = true; break;
      }
      if ($error_arg_type) {
        $count1 = $count + 1;
        pm9mvc::_abort_func_illargs("Illegal argument type(arg$count1)", $func, $rule, $args);
      }
      $count++;
    }
  }

	function pm9mvc($tpl_file=null) {
    if ($tpl_file) {
      pm9frame::pm9frame($tpl_file, T_BYFILE);

      $this->setupd = false;
      $this->serialized = false;
    }
  }

	function init_mail($tpl_file) {
    pm9mvc::_check_args(func_get_args(), 'pm9mvc::init_mail',
      array('tpl_file' => 'str'));

    $fdata = file($tpl_file);
    $tdata = '';
    foreach($fdata as $line) {
      $tdata .= rtrim($line) . "<br>\n";
    }
		pm9frame::pm9frame($tdata, T_BYVAR);

		$this->setupd = false;
		$this->serialized = false;
		$this->setup();
	}


	function set_ap_state($ap_state) {
    pm9mvc::_check_args(func_get_args(), 'pm9mvc::set_ap_state',
      array('ap_state' => 'str'));

    global $__AP_STATE;

    $__AP_STATE = $ap_state;
  }


	function init($tpl_file, $cache_time = 10000000000) {
    pm9mvc::_check_args(func_get_args(), 'pm9mvc::init',
      array('tpl_file' => 'str', 'cache_time = 0' => 'int'));

		global $__sess;
		global $__cache_time;
    global $__validate_form_list;
    global $__validate_form_counter;
    global $__frame;
    global $__history_mark;
    global $__AP_ID;
    global $__AP_STATE;
    global $__PVAR_ID;

    pm9mvc::exec_portlet($__AP_ID, $__AP_STATE);
		pm9frame::pm9frame($tpl_file, T_BYFILE);

    $__validate_form_list[$__sess['__sess_seq']][$__validate_form_counter] = array($tpl_file, $__AP_ID, $__PVAR_ID, $__AP_STATE, $__frame, $__history_mark);

    $v = $__validate_form_counter;
    $__validate_form_counter++;

		$this->setupd = false;
		$this->serialized = false;
		$this->setup();

    $LICENSE = LICENSE;

		$this->_CONTROL = "
<input type='hidden' name='__z' value='$v.{$__sess['__sess_seq']}.___SESS__SESS_SEQ___'>
<input type='hidden' name='_REFRESH' value=''>
<input type='hidden' name='_ACTION_' value=''>
<input type='hidden' name='_SESSION_READ_ONLY' value=''>
<input type='hidden' name='LICENSE' value='http://www.pm9.com::$LICENSE::20050725'>
";

		$this->_CONTROL_URL = "__z=$v.{$__sess['__sess_seq']}.___SESS__SESS_SEQ___";
		$this->_CONTROL_URL_SESSION_READ_ONLY = $this->_CONTROL_URL.'&__r=1';

		$this->assign_global('_CONTROL', $this->_CONTROL);
    $this->assign_global('_CONTROL_URL', $this->_CONTROL_URL);
    $this->assign_global('_CONTROL_URL_SESSION_READ_ONLY', $this->_CONTROL_URL_SRO);


		$__cache_time[$__AP_ID] = $cache_time;
	}


  function construct($tpl_file, $func_convert, &$rec) {
    pm9mvc::_check_args(func_get_args(), 'pm9mvc::construct',
      array('tpl_file' => 'str', 'func_convert' => 'str', 'rec' => 'array'));
    $tpl = new pm9mvc();
    $tpl->init($tpl_file);
    $tpl->set_values($func_convert, $rec);
    $tpl->finish();
  }


  function construct_ex($tpl_file, $func_convert, &$rec) {
    pm9mvc::_check_args(func_get_args(), 'pm9mvc::construct_ex',
      array('tpl_file' => 'str', 'func_convert' => 'str', 'rec' => 'array'));
    $tpl = new pm9mvc();
    $tpl->init($tpl_file);
    $tpl->set_values($func_convert, $rec);
    return $tpl;
  }


	function finish() {
		global $__AP_ID;
		global $__cache;

    $ret = $this->get_contents();
    if (stristr($ret, "checkbox")) {
		  $__cache[$__AP_ID] = preg_replace('/(?xmsi)(<input[^>]*type=([\'"]{0,1})checkbox\\2[^>]*name=([\'"]{0,1})(.*?)\\3)/', '<input type="hidden" name="$4" value="">$1', $ret);
    } else {
		  $__cache[$__AP_ID] = $ret;
    }
	}


	function last_state() {
		global $__AP_ID;
		global $__ap_last_state;

//echo "last_state()";
//var_dump($__ap_last_state);
    if ($ap_state = $__ap_last_state[$__AP_ID]) {
      pm9mvc::exec_portlet($__AP_ID, $ap_state);
//echo "<br>$ap_state<br>";
      return $ap_state;
    }
    return null;
	}


	function clear_last_state($ap_id) {
		global $__ap_last_state;

    $__ap_last_state[$ap_id] = null;
//echo "clear_last_state($ap_id)<br>";
	}


	function set_last_state() {
		global $__AP_ID;
    global $__AP_STATE;
		global $__ap_last_state;

    $__ap_last_state[$__AP_ID] = $__AP_STATE;
//echo "set_last_state()";
//var_dump($__ap_last_state);
	}


	function change_frame($frame) {
    pm9mvc::_check_args(func_get_args(), 'pm9mvc::change_frame',
      array('fname' => 'str'));

		global $__frame;

		$__frame = $frame;
	}

	function set_history_mark($history_mark) {
    pm9mvc::_check_args(func_get_args(), 'pm9mvc::set_history_mark',
      array('history_mark' => 'str'));

		global $__history_mark;

		$__history_mark = $history_mark;
	}

  function exec_portlet($ap_id, $ap_state) {
    pm9mvc::_check_args(func_get_args(), 'pm9mvc::exec_portlet',
      array('ap_id' => 'any', 'ap_state' => 'str'));

    global $__AP_ID;
    global $__cache;
    global $__sess;

    if (!$ap_id) $ap_id = $__AP_ID;
    unset($__cache[$ap_id]);
    $__sess[$ap_id]['__s'] = $ap_state;
  }

  function call_portlet_function($ap_id, $func_name, $var) {
    pm9mvc::_check_args(func_get_args(), 'pm9mvc::call_portlet_function',
      array('ap_id' => 'str', 'func_name' => 'str', 'var' => 'any'));

    require_once(APP_DIR."$ap_id/_interface.php");
    call_user_func($func_name, $var);
  }


	function __us_tpl($stpl_file, $type) {
		if ($type == T_BYFILE) {
			$serializedTPL = file($stpl_file) or
			die($this->__errorAlert('pm9mvc Error: Can\'t open [ ' . $stpl_file . ' ]!'));
		} else {
			$serializedTPL = $stpl_file;
		}

		$serializedStuff = unserialize(join ('', $serializedTPL));

		$this->_bl = $serializedStuff["_bl"];
		$this->index = $serializedStuff["index"];
		$this->parent = $serializedStuff["parent"];
	}

	function __mcrt() {
		$this->content[ PM9MVC_TOP_BLOCK . "_0" ][0] = Array(PM9MVC_TOP_BLOCK);
		$this->currentBlock = &$this->content[ PM9MVC_TOP_BLOCK . "_0" ][0];
	}

	function __assign($varname, $value) {
		if (sizeof($regs = explode('.', $varname)) == 2) {
			$ind_blockname = $regs[0] . '_' . $this->index[ $regs[0] ];

			$lastitem = sizeof($this->content[ $ind_blockname ]);

			$lastitem > 1 ? $lastitem-- : $lastitem = 0;

			$block = &$this->content[ $ind_blockname ][ $lastitem ];
			$varname = $regs[1];
		} else {
			$block = &$this->currentBlock;
		}

		$block["_t:$varname"] = $value;
	}

	function __assign_global($varname, $value) {
		$this->globalvars[ $varname ] = $value;
	}

	function __outc($blockname) {
    global $__pm9mvc_buf;
    global $unassigned_arr;

		$numrows = sizeof($this->content[ $blockname ]);

		for($i = 0; $i < $numrows; $i++) {
			$defblockname = $this->content[ $blockname ][$i][0];

			for(reset($this->_bl[ $defblockname ]); $k = key($this->_bl[ $defblockname ]); next($this->_bl[ $defblockname ])) {
				if ($k[1] == 'm') {
					$__pm9mvc_buf .= ($this->_bl[ $defblockname ][$k]);
				} else
				if ($k[1] == 't') {
					$defValue = $this->_bl[ $defblockname ][$k];

					if (!isset($this->content[ $blockname ][$i][ "_t:" . $defValue ])) {
						if (isset($this->globalvars[ $defValue ])) {
							$value = $this->globalvars[ $defValue ];
						} else {
							$value = '';
						}
					} else {
						$value = $this->content[ $blockname ][$i][ "_t:" . $defValue ];
					}

          if ($value == "\x01\x01\x01\x01") {
            $unassigned_arr[] = $defValue;
            $value = '';
          }

					$__pm9mvc_buf .= ($value);
				} else
				if ($k[1] == 'B') {
					if (isset($this->content[ $blockname ][$i][$k])) {
						$this->__outc($this->content[ $blockname ][$i][$k]);
					}
				}
			}
		}
	}


	function setup() {
		$dir = dirname($this->tpl_base[0]);
		$file = basename($this->tpl_base[0]);
		$cache_dir = $dir . '/cache/';
		$cache_file = $cache_dir . $file;
		if (@is_dir($cache_dir) && @is_readable($cache_dir)) {
			if (file_exists($cache_file) && filemtime($this->tpl_base[0]) < filemtime($cache_file)) {
				$this->tpl_base[0] = $cache_file;
				$this->tpl_base[1] = T_BYFILE;
				$this->serialized = true;
				$this->__us_tpl($this->tpl_base[0], $this->tpl_base[1]);
			} else if (is_writable($cache_dir)) {
				pm9frame::__setup();
				$fp = @fopen($cache_file, "w");
				$tmp = Array(_bl => $this->_bl, index => $this->index, parent => $this->parent);
				fputs($fp, serialize($tmp));
				fclose($fp);
				chmod($cache_file, 0777);
				$this->serialized = true;
			}
		}

		if (!$this->serialized) {
			pm9frame::__setup();
		}

		$this->setupd = true;

		$this->index[ PM9MVC_TOP_BLOCK ] = 0;
		$this->__mcrt();
	}

	function new_block($blockname) {
    pm9mvc::_check_args(func_get_args(), 'pm9mvc::new_block',
      array('blockname' => 'str'));

		$parent = &$this->content[ $this->parent[$blockname] . '_' . $this->index[$this->parent[$blockname]] ];

		$lastitem = sizeof($parent);
		$lastitem > 1 ? $lastitem-- : $lastitem = 0;

		$ind_blockname = $blockname . '_' . $this->index[ $blockname ];

		if (!isset($parent[ $lastitem ]["_B:$blockname"])) {
			$this->index[ $blockname ] += 1;

			$ind_blockname = $blockname . '_' . $this->index[ $blockname ];

			if (!isset($this->content[ $ind_blockname ])) {
				$this->content[ $ind_blockname ] = Array();
			}
			$parent[ $lastitem ]["_B:$blockname"] = $ind_blockname;
		}
		$blocksize = sizeof($this->content[ $ind_blockname ]);

		$this->content[ $ind_blockname ][ $blocksize ] = Array($blockname);
		$this->currentBlock = &$this->content[ $ind_blockname ][ $blocksize ];
	}

	function assign_global($varname, $value = '') {
		if (is_array($varname)) {
			foreach($varname as $var => $value) {
				$this->__assign_global($var, $value);
			}
		} else {
			$this->__assign_global($varname, $value);
		}
	}

	function assign($varname, $value = '') {
		if (is_array($varname)) {
			foreach($varname as $var => $value) {
				$this->__assign($var, $value);
			}
		} else {
			$this->__assign($varname, $value);
		}
	}

	function goto_block($blockname) {
    pm9mvc::_check_args(func_get_args(), 'pm9mvc::goto_block',
      array('blockname' => 'str'));

		if (isset($this->_bl[ $blockname ])) {
			$ind_blockname = $blockname . '_' . $this->index[ $blockname ];
			$lastitem = sizeof($this->content[ $ind_blockname ]);

			$lastitem > 1 ? $lastitem-- : $lastitem = 0;
			$this->currentBlock = &$this->content[ $ind_blockname ][ $lastitem ];
		}
	}

	function get_contents() {
    global $__pm9mvc_buf;
    global $unassigned_arr;
    global $__trace_mode_html_unassigned;

    $unassigned_arr = array();

    $__pm9mvc_buf = '';
    $this->__outc(PM9MVC_TOP_BLOCK . '_0');

    if ($__trace_mode_html_unassigned && count($unassigned_arr)) {
      $LOG_DIR = LOG_DIR;

      $ti = strftime('%Y/%m/%d %H:%M:%S');

      $html_fn = realpath($this->tpl_base[0]);
      $html_ti = strftime('%Y/%m/%d %H:%M:%S', filemtime($html_fn));

      $arr = debug_backtrace();
      for($i=0; $i<count($arr); $i++) {
        $php_fn = $arr[$i]['file'];
        if (strstr($php_fn, 'ThePM9.com')) continue;
        if (!(strstr($php_fn, '_include') || strstr($php_fn, '_config'))) break;
      }
      $php_ti = strftime('%Y/%m/%d %H:%M:%S', filemtime($php_fn));

      $fp = fopen("$LOG_DIR/unassigned.html", "a");
      flock($fp, LOCK_EX);
      fwrite($fp, "### $ti\n");
      fwrite($fp, "# $html_fn : $html_ti\n");
      fwrite($fp, "# $php_fn : $php_ti\n");
      foreach($unassigned_arr as $err_field) {
        fwrite($fp, "\t@@@@@@ $err_field\n");
      }
      fclose($fp);
    }

		return $__pm9mvc_buf;
	}
}

class pm9frame {
	var $tpl_base;
	var $tpl_include;
	var $tpl_count;

	var $parent = Array();
	var $_bl = Array();

	var $rootBlockName;
	var $ignore_stack;

	function pm9frame($tpl_file, $type) {
		$this->tpl_base = Array($tpl_file, $type);
		$this->tpl_count = 0;
		$this->ignore_stack = Array(false);
	}

	function __errorAlert($message) {
    trigger_error($message, E_USER_ERROR);
		print('<br>' . $message . '<br>' . "\r\n");
    pm9mvc::debug_print_backtrace();
	}

	function __setup() {
		$this->_bl[ PM9MVC_TOP_BLOCK ] = Array();
		$tplvar = $this->__setup_tpl($this->tpl_base[0], $this->tpl_base[1]);

		$initdev["varrow"] = 0;
		$initdev["coderow"] = 0;
		$initdev["index"] = 0;
		$initdev["ignore"] = false;

		$this->__parse_tpl($tplvar, PM9MVC_TOP_BLOCK, $initdev);

		for($i = 0; $i <= $this->tpl_count; $i++) {
			$tplvar = 'tpl_rawContent' . $i;
			unset($this->{$tplvar});
		}
	}

	function __setup_tpl($tpl_file, $type) {
		$tplvar = 'tpl_rawContent' . $this->tpl_count;
		if ($type == T_BYVAR) {
			$this->{$tplvar}["content"] = preg_split("/\n/", $tpl_file, -1, PREG_SPLIT_DELIM_CAPTURE);
		} else {
			$data = file($tpl_file) or
			die($this->__errorAlert('pm9mvc Error: Couldn\'t open [ ' . $tpl_file . ' ]!'));
			$this->{$tplvar}["content"] = split("\n", pm9mvc_extend_param_name(join('', $data)));
		}

		$this->{$tplvar}["size"] = sizeof($this->{$tplvar}["content"]);

		$this->tpl_count++;

		return $tplvar;
	}

	function __parse_tpl($tplvar, $blockname, $initdev) {
		$coderow = $initdev["coderow"];
		$varrow = $initdev["varrow"];
		$index = $initdev["index"];
		$ignore = $initdev["ignore"];

		while ($index < $this->{$tplvar}["size"]) {
			if (preg_match('/<!--[ ]?(START|END) IGNORE -->/', $this->{$tplvar}["content"][$index], $ignreg)) {
				if ($ignreg[1] == 'START') {
					array_push($this->ignore_stack, true);
				} else {
					array_pop($this->ignore_stack);
				}
			} else {
				if (!end($this->ignore_stack)) {
					if (preg_match('/<!--[ ]?(START|END|INCLUDE|) BLOCK : (.+)-->/', $this-> {$tplvar}["content"][$index], $regs)) {
						$regs[2] = trim($regs[2]);

						if ($regs[1] == 'INCLUDE') {
							$include_defined = true;
							if (isset($this->tpl_include[ $regs[2] ])) {
								$tpl_file = $this->tpl_include[ $regs[2] ][0];
								$type = $this->tpl_include[ $regs[2] ][1];
							} else
							if (file_exists($regs[2])) {
								$tpl_file = $regs[2];
								$type = T_BYFILE;
							} else {
								$include_defined = false;
							}

							if ($include_defined) {
								$initdev["varrow"] = $varrow;
								$initdev["coderow"] = $coderow;
								$initdev["index"] = 0;
								$initdev["ignore"] = false;

								$tplvar2 = $this->__setup_tpl($tpl_file, $type);
								$initdev = $this->__parse_tpl($tplvar2, $blockname, $initdev);

								$coderow = $initdev["coderow"];
								$varrow = $initdev["varrow"];
							}
						} else {
							if ($regs[2] == $blockname) {
								break;
							} else {
								$this->_bl[ $regs[2] ] = Array();
								$this->_bl[ $blockname ]["_B:" . $regs[2]] = '';
								$this->index[ $regs[2] ] = 0;
								$this->parent[ $regs[2] ] = $blockname;
								$index++;
								$initdev["varrow"] = 0;
								$initdev["coderow"] = 0;
								$initdev["index"] = $index;
								$initdev["ignore"] = false;

								$initdev = $this->__parse_tpl($tplvar, $regs[2], $initdev);

								$index = $initdev["index"];
							}
						}
					} else {
						$sstr = preg_split('/{(?!(\\s|$))/', $this->{$tplvar}["content"][$index]);

						reset($sstr);

						if (current($sstr) != '') {
							$this->_bl[$blockname]["_m:$coderow"] = current($sstr);
							$coderow++;
						} while (next($sstr)) {
							$pos = strpos(current($sstr), "}");

							if (($pos !== false) && ($pos > 0)) {
								$strlength = strlen(current($sstr));
								$varname = substr(current($sstr), 0, $pos);

								if (strstr($varname, ' ')) {
									$this->_bl[$blockname]["_m:$coderow"] = '{' . current($sstr);
									$coderow++;
								} else {
									$this->_bl[$blockname]["_t:$varrow" ] = $varname;
									$varrow++;
									if (($pos + 1) != $strlength) {
										$this->_bl[$blockname]["_m:$coderow"] = substr(current($sstr), ($pos + 1), ($strlength - ($pos + 1)));
										$coderow++;
									}
								}
							} else {
								$this->_bl[$blockname]["_m:$coderow"] = '{' . current($sstr);
								$coderow++;
							}
						}
					}
				} else {
					$this->_bl[$blockname]["_m:$coderow"] = $this->{$tplvar}["content"][$index];
					$coderow++;
				}
			}

			$index++;
		}

		$initdev["varrow"] = $varrow;
		$initdev["coderow"] = $coderow;
		$initdev["index"] = $index;

		return $initdev;
	}


  function log($msg) {
    $tmp_date = strftime('%Y/%m/%d %H:%M:%S');
    $fp = fopen(LOG_DIR . 'trace', 'a');
    fwrite($fp, "===========================================================");
    fwrite($fp, "\n");
    fwrite($fp, $tmp_date);
    fwrite($fp, " ");
    fwrite($fp, $_SERVER['REMOTE_ADDR']);
    fwrite($fp, "    ");
    fwrite($fp, $msg);
    fwrite($fp, "\n");
    fclose($fp);
  }
}

?>
